#include <windows.h>

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//


#ifdef __cplusplus
extern "C" {
#endif
#ifdef __cplusplus
}
#endif

//
//
//
//
//

bool __stdcall DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:  break;
        case DLL_PROCESS_DETACH:  break;
        case DLL_THREAD_ATTACH:   break;
        case DLL_THREAD_DETACH:   break;
    }
    return TRUE;
}

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//


#pragma pack(push,1)
struct RateInfo
{
   INT64             ctm;
   double            open;
   double            low;
   double            high;
   double            close;
   double            vol;
};
#pragma pack(pop)
#define minVal(a, b)  (((a) < (b)) ? (a) : (b))
#define maxVal(a, b)  (((a) > (b)) ? (a) : (b))

//
//
//
//
//

double inline __declspec (naked) __fastcall sqrt(double n)
{
	_asm fld qword ptr [esp+4]
	_asm fsqrt
	_asm ret 8
} 

//
//
//
//
//

__declspec(dllexport) void __stdcall iRWI(const RateInfo* rates, const int length, double *resultArray, const int totalRates, int i)
{
	resultArray[0] = 0;
	resultArray[1] = 0;
		i = totalRates-i-1; if (i<2) return;

	//
	//
	//
	//
	//
	//

	double rwiUp = 0;
	double rwiDo = 0;
    double atr   = maxVal(rates[i-1].high,rates[i-2].close)-minVal(rates[i-1].low,rates[i-2].close);
	double curr;


    for (int k = 1; k < length && (i-k-2)>=0; k++)
    {
        atr  += maxVal(rates[i-k-1].high,rates[i-k-2].close)-minVal(rates[i-k-1].low,rates[i-k-2].close);
            
        //
        //
        //
        //
        //
            
        double denominator  = (atr/((double)k+1.0))*sqrt((double)k+1.0);
        if (denominator != 0)
		{
			curr = (rates[i].high - rates[i-k].low) / denominator; rwiUp = maxVal(rwiUp,curr);
			curr = (rates[i-k].high - rates[i].low) / denominator; rwiDo = maxVal(rwiDo,curr);
        }
	}
	resultArray[0] = rwiUp;
	resultArray[1] = rwiDo;
    return;   
}